/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// OnCallTrying - Invoked when an outbound call is responded with a trying.    OnCallRinging - Invoked when an outbound call is ringing.    OnCallConnected - Invoked when an outbound call is answered.    OnCallFailed - Invoked when an outbound call fails to be sent.    OnCallTimeout - Invoked when an outbound call times out on no answer.    OnCallDiverted - Invoked when an outbound call is diverted to a 3rd destination.
    /// </summary>
    [DataContract]
        public partial class OutboundCallsSubscriptions :  IEquatable<OutboundCallsSubscriptions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OutboundCallsSubscriptions" /> class.
        /// </summary>
        /// <param name="onCallTrying">onCallTrying.</param>
        /// <param name="onCallRinging">onCallRinging.</param>
        /// <param name="onCallConnected">onCallConnected.</param>
        /// <param name="onCallFailed">onCallFailed.</param>
        /// <param name="onCallTimeout">onCallTimeout.</param>
        /// <param name="onCallDiverted">onCallDiverted.</param>
        public OutboundCallsSubscriptions(string onCallTrying = default(string), string onCallRinging = default(string), string onCallConnected = default(string), string onCallFailed = default(string), string onCallTimeout = default(string), string onCallDiverted = default(string))
        {
            this.OnCallTrying = onCallTrying;
            this.OnCallRinging = onCallRinging;
            this.OnCallConnected = onCallConnected;
            this.OnCallFailed = onCallFailed;
            this.OnCallTimeout = onCallTimeout;
            this.OnCallDiverted = onCallDiverted;
        }
        
        /// <summary>
        /// Gets or Sets OnCallTrying
        /// </summary>
        [DataMember(Name="onCallTrying", EmitDefaultValue=false)]
        public string OnCallTrying { get; set; }

        /// <summary>
        /// Gets or Sets OnCallRinging
        /// </summary>
        [DataMember(Name="onCallRinging", EmitDefaultValue=false)]
        public string OnCallRinging { get; set; }

        /// <summary>
        /// Gets or Sets OnCallConnected
        /// </summary>
        [DataMember(Name="onCallConnected", EmitDefaultValue=false)]
        public string OnCallConnected { get; set; }

        /// <summary>
        /// Gets or Sets OnCallFailed
        /// </summary>
        [DataMember(Name="onCallFailed", EmitDefaultValue=false)]
        public string OnCallFailed { get; set; }

        /// <summary>
        /// Gets or Sets OnCallTimeout
        /// </summary>
        [DataMember(Name="onCallTimeout", EmitDefaultValue=false)]
        public string OnCallTimeout { get; set; }

        /// <summary>
        /// Gets or Sets OnCallDiverted
        /// </summary>
        [DataMember(Name="onCallDiverted", EmitDefaultValue=false)]
        public string OnCallDiverted { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OutboundCallsSubscriptions {\n");
            sb.Append("  OnCallTrying: ").Append(OnCallTrying).Append("\n");
            sb.Append("  OnCallRinging: ").Append(OnCallRinging).Append("\n");
            sb.Append("  OnCallConnected: ").Append(OnCallConnected).Append("\n");
            sb.Append("  OnCallFailed: ").Append(OnCallFailed).Append("\n");
            sb.Append("  OnCallTimeout: ").Append(OnCallTimeout).Append("\n");
            sb.Append("  OnCallDiverted: ").Append(OnCallDiverted).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as OutboundCallsSubscriptions);
        }

        /// <summary>
        /// Returns true if OutboundCallsSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of OutboundCallsSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(OutboundCallsSubscriptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnCallTrying == input.OnCallTrying ||
                    (this.OnCallTrying != null &&
                    this.OnCallTrying.Equals(input.OnCallTrying))
                ) && 
                (
                    this.OnCallRinging == input.OnCallRinging ||
                    (this.OnCallRinging != null &&
                    this.OnCallRinging.Equals(input.OnCallRinging))
                ) && 
                (
                    this.OnCallConnected == input.OnCallConnected ||
                    (this.OnCallConnected != null &&
                    this.OnCallConnected.Equals(input.OnCallConnected))
                ) && 
                (
                    this.OnCallFailed == input.OnCallFailed ||
                    (this.OnCallFailed != null &&
                    this.OnCallFailed.Equals(input.OnCallFailed))
                ) && 
                (
                    this.OnCallTimeout == input.OnCallTimeout ||
                    (this.OnCallTimeout != null &&
                    this.OnCallTimeout.Equals(input.OnCallTimeout))
                ) && 
                (
                    this.OnCallDiverted == input.OnCallDiverted ||
                    (this.OnCallDiverted != null &&
                    this.OnCallDiverted.Equals(input.OnCallDiverted))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnCallTrying != null)
                    hashCode = hashCode * 59 + this.OnCallTrying.GetHashCode();
                if (this.OnCallRinging != null)
                    hashCode = hashCode * 59 + this.OnCallRinging.GetHashCode();
                if (this.OnCallConnected != null)
                    hashCode = hashCode * 59 + this.OnCallConnected.GetHashCode();
                if (this.OnCallFailed != null)
                    hashCode = hashCode * 59 + this.OnCallFailed.GetHashCode();
                if (this.OnCallTimeout != null)
                    hashCode = hashCode * 59 + this.OnCallTimeout.GetHashCode();
                if (this.OnCallDiverted != null)
                    hashCode = hashCode * 59 + this.OnCallDiverted.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
